#include "main.h"

char dg = 8;

void SPI_init(void)
{
	DDRB |= ((1<<PORTB2)|(1<<PORTB3)|(1<<PORTB5)); // SPI  
	PORTB &= ~((1<<PORTB2)|(1<<PORTB3)|(1<<PORTB5)); // 
	SPCR |= (1 << SPE) | (1 << MSTR)| (1<<SPR0);// ,  ,  16
}

void SPI_SendByte (char byte)
{
	SPDR = byte;
	while (!(SPSR & (1 << SPIF)));
}

void Send_7219(char rg, char dt)
{
	PORTB &= ~(1<<PORTB2);
	SPI_SendByte(rg);
	SPI_SendByte(dt);
	PORTB |= (1<<PORTB2);
}

void Clear_7219(void)
{
   char i = dg;
   // Loop until 0, but don't run for zero
   do {
	   // Set each display in use to blank
	   Send_7219(i, 0xF); //CHAR BLANK
   } while (--i);	
}

void Number_7219(volatile long n)
{
	char ng = 0; //  
	if (n < 0) 
	{
		ng = 1;
		n *= -1;
	}
	Clear_7219();
    if (n == 0) {
	    Send_7219(0x01, 0); //    0
	    return;
    }
	char i = 0;
	do {
		Send_7219(++i, n%10);
		n /= 10;
	} while (n);
	if (ng) {
		Send_7219(i+1, 0xA); // -
	}
}

void NumberFull_7219(volatile long n)
{
	int i;
	//Clear_7219();
	for(i=0;i<dg;i++)
	{
		Send_7219(i+1,(n/((long)pow(10,i)))%10);
	}
}


int main(void)
{
	unsigned int i=0;
	SPI_init();
    Send_7219(0x09, 0xFF); //  
	Send_7219(0x0B, dg - 1); //  
	Send_7219(0x0A, 0x02); //
	Send_7219(0x0C, 1); // 
	Clear_7219();
	Send_7219(0x01, 1);
	Send_7219(0x02, 2);
	Send_7219(0x03, 3);
	Send_7219(0x04, 4);
	Send_7219(0x05, 5);
	Send_7219(0x06, 6);
	Send_7219(0x07, 7);
	Send_7219(0x08, 8);
 	_delay_ms(1000);
 	Number_7219(-2016);
 	_delay_ms(1000);
	while(1)
 	{
 		NumberFull_7219(i);
 		i++;
 		_delay_ms(500);
	}
}